EDIT - bug #2495

IpniServiceTest fails from time to time
07/18/2011 10:17 AM - Andreas Kohlbecker

Status: Feedback Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 0%
Category: cdmlib Estimated time: 0:00 hour
Target version: Reviewed Next Major Release

Severity: normal Found in Version:

Description

eu.etaxonomy.cdm.ext.ipni.lpniService Test.testPublications

java.lang.NullPointerException

at eu.etaxonomy.cdm.ext.ipni.IpniServiceTest.testPublications (IpniServiceTest. java:175)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:39)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:25)

at java.lang.reflect.Method.invoke (Method. java:597)

at org.junit.runners.model.FrameworkMethod$l.runReflectiveCall (FrameworkMethod. java:44)

at org.junit.internal.runners.model.ReflectiveCallable.run (ReflectiveCallable. java:15)

at org.junit.runners.model.FrameworkMethod.invokeExplosively (FrameworkMethod. java:41)

at org.junit.internal.runners.statements.InvokeMethod.evaluate (InvokeMethod. java:20)

at org.junit.internal.runners.statements.RunBefores.evaluate (RunBefores. java:28)

at org.junit.internal.runners.statements.RunAfters.evaluate (RunAfters. java:31)

at org.junit.runners.BlockJUnit4ClassRunner.runChild(BlockJUnit4ClassRunner. java:70)

at org.junit.runners.BlockJUnit4ClassRunner.runChild(BlockJUnit4ClassRunner. java:44)

at org.junit.runners.ParentRunner.runChildren (ParentRunner. java:180)

at org.junit.runners.ParentRunner.access$000 (ParentRunner. java:41)

at org.junit.runners.ParentRunner$l.evaluate (ParentRunner. java:173)

at org.junit.internal.runners.statements.RunBefores.evaluate (RunBefores. java:28)

at org.junit.internal.runners.statements.RunAfters.evaluate (RunAfters. java:31)

at org.junit.runners.ParentRunner.run (ParentRunner. java:220)

at org.apache.maven.surefire.junit4.JUnit4TestSet.execute (JUnit4TestSet. java:62)

at org.apache.maven.surefire.suite.AbstractDirectoryTestSuite.executeTestSet (AbstractDirectory
TestSuite. java:140)

at org.apache.maven.surefire.suite.AbstractDirectoryTestSuite.execute (AbstractDirectoryTestSui
te.java:127)

at org.apache.maven.surefire.Surefire.run (Surefire.java:177)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:39)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:25)

at java.lang.reflect.Method.invoke (Method. java:597)

at org.apache.maven.surefire.booter.SurefireBooter.runSuitesInProcess (SurefireBooter.java:345)

at org.apache.maven.surefire.booter.SurefireBooter.main (SurefireBooter. java:1009)

Related issues:
Blocked by EDIT - bug #6415: Create test suite for availability testing of ex... New

Associated revisions

Revision 92211195 - 02/10/2017 05:17 PM - Andreas Kohlbecker

prevent ipni tests from failing when external server is absent

Revision d5020a07 - 02/13/2017 11:02 AM - Andreas Kohlbecker

ref #2495 Revert "prevent ipni tests from failing when external server is absent

This reverts commit 9a211f95133eddfd9fe49a25bbd22ca4a5b841c5.

History

#1 - 07/18/2011 10:17 AM - Andreas Kohlbecker
- Target version set to cdmlib RELEASE 3.0.7

#2 - 07/18/2011 11:02 AM - Andreas Miiller
- Target version deleted (cdmlib RELEASE 3.0.7)
- Priority changed from Priority08 to Highest

#3 - 02/10/2017 05:27 PM - Andreas Kohlbecker

- Description updated

- Status changed from New to Closed

- Assignee changed from Andreas Miiller to Andreas Kohlbecker

- Target version changed from cdmlib - Old Next Major Release to Release 4.6

fixed by 92211f9
this is actually very quick and easy to achieve:

@Before
public void setUp () throws Exception ({
// run the tests only when the server is available
Assume.assumeTrue (UriUtils.isServiceAvailable (new URI (
"http://www.uk.ipni.org/ipni/simplePlantNameSearch.do?find_wholeName=Abies+albertiana&output_format=delimited-
short"), 1000));
// prepare tests
servicel = new IpniService();

}

The test are all successful if the server is absent!

#4 - 02/10/2017 09:34 PM - Andreas Miiller
- Status changed from Closed to Feedback

Andreas Kohlbecker wrote:

fixed by 9a211f9
this is actually very quick and easy to achieve:

The test are all successful if the server is absent!

But this is only one part of the tasks that need to be done.

Second step: Create a test that fails when and only when the service is unavailable. This test must not be included in the cdmlib maven test but run
separately in jenkins.

If we do not have this test we can not see if a service is permanently down or has changed its URL syntax/location, but this is crucial to guarantee that
the external services work.

Also we should implement this for ALL external service tests.
#5 - 02/13/2017 08:21 AM - Andreas Kohlbecker
- Status changed from Feedback to Closed
- Private changed from Yes to No
Andreas Milller wrote:
Andreas Kohlbecker wrote:
fixed by 9a211f9
this is actually very quick and easy to achieve:

The test are all successful if the server is absent!

But this is only one part of the tasks that need to be done.

03/20/2024 2/4


https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/9a211f95133eddfd9fe49a25bbd22ca4a5b841c5
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/9a211f95133eddfd9fe49a25bbd22ca4a5b841c5
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/9a211f95133eddfd9fe49a25bbd22ca4a5b841c5

Second step: Create a test that fails when and only when the service is unavailable. This test must not be included in the cdmlib maven test but
run separately in jenkins.

If we do not have this test we can not see if a service is permanently down or has changed its URL syntax/location, but this is crucial to
guarantee that the external services work.

Also we should implement this for ALL external service tests.

This is a good suggestion. However, we should not implement these tests as part of the cdm library for the following reasons:

1. Sooner or later you will be faced with the task to do more in depth testing than only to check for HTTP Status codes. You would be starting to
implement a couple of helper methods in this situation which grow after a while towards a little framework. But, It makes not much sense to
reinvent the wheel of a web service testing framework. There are excellent tools out there, For example Gatling.

2. Having these tests in a separate project will reduce the confusion, since these tests could be run automatically by the default way. Otherwise you
need a naming convention for these tests to run them in a separate suite.

3. The cdmlib is not the only project which depends on external services. Testing external services is a more general taks for the BDI and also for
external projects.

Please open a new ticket, since this one is completed. The subject and issue description do not mention this second step by the way!

#6 - 02/13/2017 10:24 AM - Andreas Miiller
- Status changed from Closed to Feedback

#7 - 02/13/2017 10:26 AM - Andreas Mdiller

Andreas Kohlbecker wrote:
Andreas Muller wrote:

Andreas Kohlbecker wrote:
This is a good suggestion. However, we should not implement these tests as part of the cdm library for the following reasons:

1. Sooner or later you will be faced with the task to do more in depth testing than only to check for HTTP Status codes. You would be starting
to implement a couple of helper methods in this situation which grow after a while towards a little framework. But, It makes not much sense
to reinvent the wheel of a web service testing framework. There are excellent tools out there, For example Gatling.

2. Having these tests in a separate project will reduce the confusion, since these tests could be run automatically by the default way.
Otherwise you need a naming convention for these tests to run them in a separate suite.

3. The cdmlib is not the only project which depends on external services. Testing external services is a more general taks for the BDI and also
for external projects.

Please open a new ticket, since this one is completed. The subject and issue description do not mention this second step by the way!

| did not say that we should integrate these tests into cdmlib. But they need to be in place before we can switch off availability testing within cdmlib.
Until then we have to revert this ticket, therefore reopened it.

#8 - 02/13/2017 10:30 AM - Andreas Miiller

- Blocked by bug #6415: Create test suite for availability testing of external services added

#9 - 02/13/2017 12:04 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Miller

| applied this fix because | was blocked by the IPNI Service not being available for quite some time. The cdmlib could not be build and the whole build
pipeline was blocked due to this. This Problem also can break any release. | don't agree with you in this, but | reverted the fix as you requested and
will no longer work in this ticket, it's your turn!

#10 - 03/10/2017 01:34 AM - Andreas Miiller

- Target version changed from Release 4.6 to Release 4.7

#11 - 05/04/2017 12:44 AM - Andreas Miiller

- Target version changed from Release 4.7 to Release 4.8

#12 - 07/06/2017 11:18 PM - Andreas Miiller

- Target version changed from Release 4.8 to Release 4.9

#13 - 07/21/2017 11:19 AM - Andreas Miiller
- Target version changed from Release 4.9 to Release 4.10

#14 - 09/24/2017 10:30 PM - Andreas Miiller

- Target version changed from Release 4.10 to Release 4.11

#15 - 11/08/2017 11:51 AM - Andreas Muller

- Target version changed from Release 4.11 to Release 4.12

#16 - 12/05/2017 02:39 PM - Andreas Miiller

- Target version changed from Release 4.12 to Release 4.13

#17 - 01/30/2018 11:33 AM - Andreas Muller

- Target version changed from Release 4.13 to Release 4.14

#18 - 02/14/2018 02:08 PM - Andreas Miiller

- Target version changed from Release 4.14 to Release 5.0

#19 - 04/30/2018 04:02 PM - Andreas Miiller

- Target version changed from Release 5.0 to Release 5.1

#20 - 06/12/2018 11:15 AM - Andreas Muller

- Target version changed from Release 5.1 to Release 5.3

#21 - 09/05/2018 07:39 AM - Andreas Miiller

- Target version changed from Release 5.3 to Release 5.4

#22 - 09/05/2018 07:42 AM - Andreas Miiller

- Target version changed from Release 5.4 to Release 5.5

#23 - 01/14/2019 11:58 AM - Andreas Muller

- Target version changed from Release 5.5 to Release 5.6

#24 - 03/22/2019 06:21 PM - Andreas Miiller

- Target version changed from Release 5.6 to Release 5.7

#25 - 03/22/2019 06:22 PM - Andreas Miiller

- Target version changed from Release 5.7 to Reviewed Next Major Release
